//-----------------------------------------------------------------------------
//
//			->	 02 -  Direct3D   
//			->	http://www.firststeps.ru
//	  31.07.2002
//
//-----------------------------------------------------------------------------
#define APPNAME "http://www.firststeps.ru    02 -  Direct3D   "
#define APPTITLE "http://www.firststeps.ru    02 -  Direct3D   "

#define _RELEASE_(p) { if(p) { (p)->Release(); (p)=NULL; };};
#define _DELETE_(p)  { if(p) { delete (p);     (p)=NULL; };};

#include <windows.h>
#include <d3d8.h>

#pragma comment (lib, "d3d8.lib")

LPDIRECT3D8             p_d3d        = NULL;		//    d3d8
LPDIRECT3DDEVICE8       p_d3d_Device = NULL;		//   d3d8

HWND hWnd;

//-----------------------------------------------------------------------------
// Name: WindowProc ()
// Desc: 
//-----------------------------------------------------------------------------
LRESULT CALLBACK WindowProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_DESTROY:
		PostQuitMessage (0);
		break;

	case WM_SETCURSOR:
		SetCursor (NULL);
		break; 
	};
	return DefWindowProc(hWnd, message, wParam, lParam);
};

//-----------------------------------------------------------------------------
// Name: WindowInit ()
// Desc: 
//-----------------------------------------------------------------------------
bool WindowInit (HINSTANCE hThisInst, int nCmdShow)
{
	WNDCLASS		    wcl;
		
	wcl.hInstance		= hThisInst;
	wcl.lpszClassName	= APPNAME;
	wcl.lpfnWndProc		= WindowProc;
	wcl.style			= 0;

	wcl.hIcon			= LoadIcon (hThisInst, IDC_ICON);
	wcl.hCursor			= LoadCursor (hThisInst, IDC_ARROW);
	wcl.lpszMenuName	= NULL;

	wcl.cbClsExtra		= 0;
	wcl.cbWndExtra		= 0;
	wcl.hbrBackground	= (HBRUSH) GetStockObject (BLACK_BRUSH);

	RegisterClass (&wcl);

	hWnd = CreateWindowEx (
		WS_EX_TOPMOST,
		APPNAME,
		APPTITLE,
		WS_OVERLAPPEDWINDOW,
		0, 0, 
		640,
		480,
		NULL,
		NULL,
		hThisInst,
		NULL);

	if(!hWnd) return false;

	return true;
};

//-----------------------------------------------------------------------------
// Name: AppInit()
// Desc: Initializes Aplication
//-----------------------------------------------------------------------------
bool AppInit (HINSTANCE hThisInst, int nCmdShow)
{
	if(!WindowInit (hThisInst, nCmdShow)) return false;
	ShowWindow (hWnd, nCmdShow);
	UpdateWindow (hWnd);
	
	p_d3d = Direct3DCreate8 (D3D_SDK_VERSION);
	
	D3DDISPLAYMODE d3ddm;
	p_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &d3ddm);

	D3DPRESENT_PARAMETERS d3dpp; 
	ZeroMemory (&d3dpp, sizeof(d3dpp));
	d3dpp.Windowed = true;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferFormat = d3ddm.Format;

	p_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
		D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpp, &p_d3d_Device);

	return true;
};

//-----------------------------------------------------------------------------
// Name: DestroyDirect3D8 ()
// Desc: 
//-----------------------------------------------------------------------------
void DestroyDirect3D8 (void)
{
	_RELEASE_ (p_d3d_Device);
	_RELEASE_ (p_d3d);
};

//-----------------------------------------------------------------------------
// Name: WinMain ()
// Desc: 
//-----------------------------------------------------------------------------
int APIENTRY WinMain (HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	if(!AppInit (hThisInst, nCmdShow)) return false;
	
	while (1)
	{
		if(PeekMessage (&msg, NULL, 0, 0, PM_NOREMOVE))
		{
			if(!GetMessage (&msg, NULL, 0, 0)) break;
			TranslateMessage (&msg); 
			DispatchMessage (&msg);
		}
	};

	DestroyDirect3D8 ();

	return 0;
};

//-----------------------------------------------------------------------------
// EOF
//-----------------------------------------------------------------------------